"""Update permissions table

Revision ID: a485f329301a
Revises: c191d7a11c89
Create Date: 2023-12-07 00:22:30.401585

"""
from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import mysql

# revision identifiers, used by Alembic.
revision = 'a485f329301a'
down_revision = 'c191d7a11c89'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table('group_permissions', schema=None) as batch_op:
        batch_op.drop_index('ix_group_permissions_updated_at')
        batch_op.drop_column('updated_at')

    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table('group_permissions', schema=None) as batch_op:
        batch_op.add_column(sa.Column('updated_at', mysql.DATETIME(), nullable=False))
        batch_op.create_index('ix_group_permissions_updated_at', ['updated_at'], unique=False)

    # ### end Alembic commands ###
